% Beispielimplementierung zu Aufgabe 1.3
function []= Blatt1()
clear all; close all; clc;

% Parameter
a=2; c=1; T=2;

h=2;
% a>c, d.h. die Person ist schneller
hund(a,c,T,h,1)
%hund(a,c,T,h,2)

% a<c, d.h. der Hund ist schneller
%hund(c,a,T,h,1)
hund(c,a,T,h,2)

% Beide sind gleichschnell
%hund(a,a,T,h,1)
hund(a,a,T,h,2)

h=0.01;
% a>c, d.h. die Person ist schneller
%hund(a,c,T,h,1)
hund(a,c,T,h,2)

% a<c, d.h. der Hund ist schneller
%hund(c,a,T,h,1)
hund(c,a,T,h,2)

% Beide sind gleichschnell
%hund(a,a,T,h,1)
hund(a,a,T,h,2)


function []= hund(a,c,T,h,modus)
% Es ist:
% a: die Geschwindigkeit der Person
% c: die Geschwindigkeit des Hundes
% T: der Endzeitpunkt
% h: die Zeitschrittweite
% modus: legt fest ob zuerst die Person einen Schritt macht (modus = 1) oder ob
% zuerst der Hund einen Schritt macht (modus = 2)

% Zeitintervall diskretisieren
t=0:h:T;
% Anzahl Zeitpunkte
nt=length(t);
% Vektoren für x,y-Position Hund
x=zeros(1,nt);
y=zeros(1,nt);
% Position Person
z=zeros(1,nt);
% Anfangswerte
x(1)=-1;
y(1)=0;
z(1)=0; % offenbar ist die x-Position der Person immer 0
% Umsetzung des schrittweisen Ablaufs 
for i=2:nt
    if modus == 1
        z(i)=z(i-1)+a*h; % Zuerst geht die Person einen Schritt
        % Für die neue Position des Hundes, benötigen wir den Abstand zwischen
        % Hund und Person, vgl. auch Diskussion in der ÜB
        dist= norm([x(i-1),y(i-1)-z(i)]);
        % Neue Position des Hundes - vgl. Strahlensatz
        x(i)=x(i-1)+c*h*(0-x(i-1))/dist;
        y(i)=y(i-1)+c*h*(z(i)-y(i-1))/dist;
    elseif modus == 2
        % Wir bestimmen zuerst den Abstand zwischen der Person und dem Hund
        dist= norm([x(i-1),y(i-1)-z(i-1)]);
        % Und damit wie gehabt die neue Position des Hundes
        x(i)=x(i-1)+c*h*(0-x(i-1))/dist;
        y(i)=y(i-1)+c*h*(z(i-1)-y(i-1))/dist;
        % Schließlich die neue Position der Person
        z(i)=z(i-1)+a*h;
    end
end

% figure-Einstellungen:
figure
% Beschriftung x,y-Achse
xlabel('x-Achse')
ylabel('y-Achse')
% Plot-titel
string=['Hund (Geschwindigkeit c=',num2str(c),') und Person (Geschwindigkeit a=',num2str(a),')'];
title(string)
% Axen fixieren (optional)
axis([-1.05,0.1,-0.05,a*T+0.7])
% weiterer Text (optional)
string=['Time step h=',num2str(h)];
text(-1,1,string)
if modus == 1
    text(-1,2,'Hund geht auf die neue Position zu')
elseif modus == 2
    text(-1,2,'Hund geht auf die alte Position zu')
end

hold on

% schrittweiser Plot:
pausetime=0.05;
for i=2:nt 
    plot([x(i-1),x(i)],[y(i-1),y(i)],'r.-')
    pause(pausetime)
    plot(0,z(i),'.g')
    pause(pausetime)
end